<?php
/*
Plugin Name: License Manager - Clients
Plugin URI: http://pickplugins.com
Description: Awesome Question and Answer.
Version: 1.0.28
Text Domain: question-answer
Author: pickplugins
Author URI: http://pickplugins.com
License: GPLv2 or later
License URI: http://www.gnu.org/licenses/gpl-2.0.html
*/

if ( ! defined('ABSPATH')) exit;  // if direct access 


class LicenseManagerClients_PluginSlug{
	
	public function __construct(){
	
		$this->_define_constants();
	
		register_activation_hook( __FILE__, array( $this, 'activation' ) );
		register_deactivation_hook( __FILE__, array( $this, 'deactivation' ) );		
		add_filter('cron_schedules', array( $this, 'scheduled_interval' ));
		add_action('license_manager_cron_license_check', array( $this, 'license_last_check' ));
		add_action( 'admin_menu', array( $this, 'admin_menu' ), 12 );
		
		
				
	}
	

	
	public function admin_menu() {
		
		add_menu_page( 'active_license', 'License Active' ,  'manage_options', 'license', array( $this, 'license' ) );

	}
	
	public function license(){
		include( LICENSE_MANAGER_CLIENTS_PLUGIN_DIR. 'license.php' );
		
	}	
	
	
	public function license_last_check() {
		
		//update_option('plugin_slug_license_int', 'hhhhhhhhhhhhh3' );
		
		
		$plugin_slug_license = get_option('plugin_slug_license');
		
		if(!empty($plugin_slug_license['license_key'])){
			$license_key = $plugin_slug_license['license_key'];
			}
		else{
			$license_key = '';
			}

		//$domain = '';
		$admin_email = get_option('admin_email');
	
		if(is_multisite()){
			
				$domain = site_url();
			}
		else{
				$domain = $_SERVER['SERVER_NAME'];
			}
		

		
		// API query parameters
		$api_params = array(
			'_action' => '_activate',
			//'secret_key' => plugin_slug_SPECIAL_SECRET_KEY,
			'admin_email' => $admin_email,
			'license_key' => $license_key,
			'registered_domain' => $domain,
			//'order_id' => urlencode(plugin_slug_ITEM_REFERENCE),
		);
	
		// Send query to the license manager server
		$response = wp_remote_get(add_query_arg($api_params, LICENSE_MANAGER_SERVER_URL), array('timeout' => 20, 'sslverify' => false));
	
		// Check for error in the response
		if (is_wp_error($response)){
			echo __("Unexpected Error! The query returned with an error.", LICENSE_MANAGER_TEXTDOMAIN);
			}
		else{
				//var_dump($response);//uncomment it if you want to look at the full response
			
				// License data.
				$license_data = json_decode(wp_remote_retrieve_body($response));
				//var_dump($license_data);
				//echo $license_data->message;
			
			
			
			
				if(!empty($license_data->license_key)){
					$license_key = sanitize_text_field($license_data->license_key);
					}
				else{
					$license_key = '';
					}			
			
			
			
				if(!empty($license_data->date_created)){
					$date_created = sanitize_text_field($license_data->date_created);
					}
				else{
					$date_created = '';
					}
					
					
			
				if(!empty($license_data->date_expiry)){
					
					$date_expiry = sanitize_text_field($license_data->date_expiry);
					
					}	
				else{
					$date_expiry = '';
					}		
			
				if(!empty($license_data->license_status)){
					
					$license_status = sanitize_text_field($license_data->license_status);
					
					}	
				else{
					$license_status = '';
					}		
			
			
				if(!empty($license_data->license_found)){
					
					$license_found = sanitize_text_field($license_data->license_found);
					
					}			
				else{
					$license_found = '';
					}

				$plugin_slug_license = array(
											'license_key'=>$license_key,
											'date_created'=>$date_created,
											'date_expiry'=>$date_expiry,
											'license_status'=>$license_status,
											'license_found'=>$license_found,
											);
				
				update_option('plugin_slug_license', $plugin_slug_license );
			
			}








		
	}	
	
	
		

	
	
	
	
	
	
	
	
	
	
	
	

	public function days_remaining($date_expiry) {
		


		$gmt_offset = get_option('gmt_offset');
		$today = date('Y-m-d h:i:s', strtotime('+'.$gmt_offset.' hour'));
		$today = strtotime($today);
		//var_dump(strtotime($today));
		$response = array();
		$response['class'] = 'active';
		
		
		$date_expiry = strtotime($date_expiry);
		//$today = time();		
		
		//var_dump($today);
		
		
		$diff = $date_expiry-$today;
		
		if($diff<0){
			
			$response['diff'] = $diff;			
			$response['text'] = __('Expired', LICENSE_MANAGER_CLIENTS_TEXTDOMAIN);
			$response['class'] = 'expired';
			}
		else{
			
			$minute = floor(($diff % 3600)/60);
			$hour = floor(($diff % 86400)/3600);
			$day = floor(($diff % 2592000)/86400);
			$month = floor($diff/2592000);
			$year = floor($diff/(86400*365));		
			
			if($year>0){
				$response['text'] =  number_format_i18n($year) .' '.__('year', LICENSE_MANAGER_CLIENTS_TEXTDOMAIN);
				}
					
			elseif($month > 0 && $day<=12 ){
				$response['text'] = number_format_i18n($month) .' '.__('month', LICENSE_MANAGER_CLIENTS_TEXTDOMAIN);
				}
				
			elseif($day > 0 && $day<=30){
				$response['text'] = number_format_i18n($day).' '.__('day', LICENSE_MANAGER_CLIENTS_TEXTDOMAIN);
				}
				
			elseif($hour > 0 && $hour<=24){
				$response['text'] = number_format_i18n($hour).' '.__('hour', LICENSE_MANAGER_CLIENTS_TEXTDOMAIN);
				}		
				
			elseif($minute > 0 && $minute<60){
				$response['text'] = number_format_i18n($minute).' '.__('minute', LICENSE_MANAGER_CLIENTS_TEXTDOMAIN);
				}	
					
			else{
				$response['text'] = $diff.' '.__('second', LICENSE_MANAGER_CLIENTS_TEXTDOMAIN);;
				}
			
			}
		
		

			
			
		return $response;	
			
			
			
			
		
	
		
		}

		
	
	
	public function activation() {

		wp_schedule_event(time(), 'minute', 'license_manager_cron_license_check');

		
	}
	
	public function scheduled_interval($interval) {
	
		$interval['minute'] = array('interval' => 60, 'display' => 'Minute');	
		$interval['weekly'] = array('interval' => 60*60*24*7, 'display' => 'Weekly');
	
		return $interval;
	}
	
	
	public function deactivation() {

		wp_clear_scheduled_hook('license_manager_cron_license_check');

		
	}	
	
	


	
	
	public function _define_constants() {
		

		$this->define('LICENSE_MANAGER_CLIENTS_PLUGIN_URL', plugins_url('/', __FILE__)  );
		$this->define('LICENSE_MANAGER_CLIENTS_PLUGIN_DIR', plugin_dir_path( __FILE__ ) );	
		$this->define('LICENSE_MANAGER_CLIENTS_PLUGIN_NAME', 'LICENSE MANAGER Clients' );			
		$this->define('LICENSE_MANAGER_CLIENTS_TEXTDOMAIN', 'license-manager-clients' );	
		$this->define('LICENSE_MANAGER_CLIENTS_VERSION', '1.0.0' );						
		$this->define('LICENSE_MANAGER_SERVER_URL', '' ); // put the server URL where you install 'License Manager' plugin	
		
	}
	
	private function define( $name, $value ) {
		if( $name && $value )
		if ( ! defined( $name ) ) {
			define( $name, $value );
		}
	}


	
	
} 

new LicenseManagerClients_PluginSlug();